poj3683 Priest John's Busiest Day

不用topsort的,我也不知道为啥。

#include <iostream>
#include <cstring>
#include <cstdio>
using namespace std;
struct Node{
    int fro, too;
}nd[2005];
struct Edge{
    int too, nxt, val;
}edge[4000005];
int uu, vv, ww, n, hea[2005], cnt, dfn[2005], loo[2005], scc, bel[2005];
int sta[2005], din, ind;
bool ins[2005];
bool pd(int x, int y){
    if(nd[x].fro<=nd[y].fro && nd[x].too>nd[y].fro) return true;
    swap(x, y);
    if(nd[x].fro<=nd[y].fro && nd[x].too>nd[y].fro) return true;
    return false;
}
void add_edge(int fro, int too){
    edge[++cnt].nxt = hea[fro];
    edge[cnt].too = too;
    hea[fro] = cnt;
}
void tarjan(int u){
    dfn[u] = loo[u] = ++ind;
    sta[++din] = u;
    ins[u] = true;
    for(int i=hea[u]; i; i=edge[i].nxt){
        int t=edge[i].too;
        if(!dfn[t]){
            tarjan(t);
            loo[u] = min(loo[u], loo[t]);
        }
        else if(ins[t]) loo[u] = min(loo[u], dfn[t]);
    }
    int j;
    if(dfn[u]==loo[u]){
        scc++;
        do{
            j = sta[din--];
            ins[j] = false;
            bel[j] = scc;
        }while(dfn[j]!=loo[j]);
    }
}
int main(){
    cin>>n;
    for(int i=0; i<n; i++){
        scanf("%d:%d", &uu, &vv);
        uu = uu * 60 + vv;
        scanf("%d:%d", &vv, &ww);
        vv = vv * 60 + ww;
        scanf("%d", &ww);
        nd[2*i].fro = uu, nd[2*i].too = uu + ww;
        nd[2*i+1].fro = vv - ww, nd[2*i+1].too = vv;
    }
    for(int i=0; i<n+n; i++)
        for(int j=i+1; j<n+n; j++)
            if(pd(i, j)){
                add_edge(i, j^1);
                add_edge(j, i^1);
            }
    for(int i=0; i<n+n; i++)
        if(!dfn[i])
            tarjan(i);
    for(int i=0; i<n+n; i+=2)
        if(bel[i]==bel[i^1]){//说明以前有要求既不能选i又不能选i^1
            printf("NO\n");
            return 0;
        }
    printf("YES\n");
    for(int i=0; i<n+n; i+=2){
        int id=bel[i]<bel[i^1]?i:i+1;//为什么要这样做?id小说明先求出来,在图里是靠近下游的,影响小
        printf("%02d:%02d %02d:%02d\n", nd[id].fro/60, nd[id].fro%60, nd[id].too/60, nd[id].too%60);
    }
    return 0;
}

poj3683 Priest John's Busiest Day

时间: 2024-10-08 10:42:13

poj3683 Priest John's Busiest Day的相关文章

POJ-3683 Priest John&#39;s Busiest Day

图论中的2-SAT.模板题. #include <cstdio> #include <cstdlib> #include <algorithm> #include <cctype> #include <cstring> #include <iostream> using namespace std; #define rep(i, l, r) for(int i=l; i<=r; i++) #define travel(x) fo

Poj3683:Priest John&#39;s Busiest Day

题意 n对夫妻要结婚,第i对夫妻结婚的婚礼持续时间为[Si, Ti],他们会举行一个仪式,仪式时间为Di,这个仪式只能举行在开头或者结尾举行,要么[Si, Si+Di],要么[Ti-Di, Ti],然而举行仪式的牧师只有一个,问牧师能否举行完所有仪式 按输入顺序输出方案 手动翻译 Sol \(2-SAT\)输出一组可行解 这个很烦 \(Tarjan\)缩点成\(DAG\)后再拓扑排序+染色 只传递不选的标记 # include <iostream> # include <stdio.h&

HDU2491 Priest John&#39;s Busiest Day

题目链接 题意: 有n个人要进行乒乓球比赛,每个人都一个能力值,每个人出现的次序就是他们住的位置 现在要求进行一场比赛,三个人,裁判的能力值在两个选手之间,住的位置也在两个人的之间 问这种比赛一共可以进行多少次 思路: 用树状数组做,否则TLE,先从左到右扫一遍,计算每点左边大的个数和小的个数, 再从右到左扫一遍,计算每点右边大和小的个数,然后交叉相乘取和就可以了 代码如下: #include<cstdio> #include<cstring> #include<string

UVA - 1420 Priest John&#39;s Busiest Day

题目大意:有一个司仪,要主持 n 场婚礼,给出婚礼的起始时间和终止时间,每个婚礼需要超过一半的时间做为仪式,并且仪式不能终止.问说司仪能否主持 n 场婚礼. 解题思路:贪心,为了尽量主持多的婚礼,每场的仪式时间就一定要尽量短 d = (t - s) / 2 + 1,(因为必须大于一半,所以加 1).然后按照每场婚礼可以最晚结束的时间排序 t - d,(因为要满足所有的婚礼,所以尽量解决早点的仪式,腾出时间来给后面的婚礼),维护一个占用时间值即可. #include <cstdio> #incl

POJ 3683 Priest John&#39;s Busiest Day (2-SAT+输出可行解)

题目地址:POJ 3683 第一次做需要输出可行解的题目...大体思路是先用强连通来判断是否有可行解,然后用逆序建图,用拓扑排序来进行染色,然后输出可行解.具体思路见传送门 因为判断的时候少写了一个等号..检查了好长时间..sad... 代码如下: #include <iostream> #include <cstdio> #include <string> #include <cstring> #include <stdlib.h> #incl

POJ 3683(Priest John&#39;s Busiest Day-强连通分量解决2-SAT)[Template:2-SAT]

Priest John's Busiest Day Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 8144   Accepted: 2769   Special Judge Description John is the only priest in his town. September 1st is the John's busiest day in a year because there is an old le

POJ 3683.Priest John&#39;s Busiest Day 2-SAT

Priest John's Busiest Day Time Limit: 2000MS   Memory Limit: 65536K Total Submissions: 10144   Accepted: 3472   Special Judge Description John is the only priest in his town. September 1st is the John's busiest day in a year because there is an old l

POJ 3683 Priest John&#39;s Busiest Day(2-SAT)

[题目链接] http://poj.org/problem?id=3683 [题目大意] 每个婚礼有两个时段可以进行特别仪式,特别仪式必须要有神父在场, 神父只有一个,问是否能满足所有婚礼的需求, [题解] 因为两个时段必须要满足一个时段,所以如果一个时段被占用那么另一个时段必须被空出来, 我们根据各个婚礼两个时段之间的冲突关系建边,之后跑2-SAT,判断是否冲突, 若无冲突则输出方案. [代码] #include <cstdio> #include <algorithm> #in

HDU 2491 Priest John&#39;s Busiest Day(贪心)

题目链接 题意: n场婚礼 给定每场婚礼的开始和结束时间,要求每场婚礼至少举行一半以上(不包括一半) 如果可行输出YES,否则输出NO 思路: 算出每场婚礼的至少要举行的时间t, 最早的结束时间mid 以最早结束时间mid为第一变量,开始时间s为第二变量从小到大排序 用cnt记录举办完每场婚礼的结束时间 分三种情况: ①加参前当婚礼的时间够不一半 ②果加参婚礼时婚礼已开始,结束时间就加上婚礼一半的时光 ③婚礼没开始,结束时间就是婚礼的最早结束时间mid 代码如下: #include<cstdio